###########################################
# ----------- [ CONFIGURATION ] -----------
###########################################

WIFI_SSID = 'KUWIN-IOT'
WIFI_PASS = ''
MQTT_BROKER = 'iot.cpe.ku.ac.th'
MQTT_USER = 'b6610505314'
MQTT_PASS = 'jurin.se@ku.th'


###########################################
# --------------- [ WIFI ] ---------------
###########################################

import network, time

wifi = network.WLAN(network.STA_IF)

def connect_wifi():
    mac = ':'.join(f'{b:02X}' for b in wifi.config('mac'))
    print(f'WiFi MAC address is {mac}')
    wifi.active(True)
    print(f'Connecting to WiFi {WIFI_SSID}.')
    wifi.connect(WIFI_SSID, WIFI_PASS)
    while not wifi.isconnected():
        print('.', end='')
        time.sleep(0.5)
    print('\nWiFi connected.')

###########################################
# --------------- [ MQTT ] ---------------
###########################################

from umqtt.simple import MQTTClient
import TOPIC

mqtt = MQTTClient(client_id='',
                  server=MQTT_BROKER,
                  user=MQTT_USER,
                  password=MQTT_PASS)

def connect_mqtt():
    print(f'Connecting to MQTT broker at {MQTT_BROKER}.')
    mqtt.connect()
    mqtt.set_callback(TOPIC.mqtt_callback)
    TOPIC.subscribe_topics()
    print('MQTT broker connected.')
    print('-'*20)