\<head\> \<style\> .eng { font-family: Trebuchet MS; font-weight: bold;
} .mode { color: blue; font-weight: bold; } .file { color: purple;
font-weight: bold; font-family: monospace; } .topic { color: #5F9EA0;
font-style: italic; } \</style\>\</head\>

\<h1 class=\"eng\"\> UTILITY OF PROJECT \</h1\>

In our daily lives, we\'re surrounded by various sounds---from
conversations to car noises, and music is among them. For musicians,
sound clarity is crucial; clear separation reduces distortion and
enhances performance. Without it, music rehearsals lack effectiveness.
Hence, this project aims to aid in sound separation, facilitating
smoother, more efficient music practice. Additionally, it merges
knowledge from two subjects: hardware and music.

\-\--

\<h1 class=\"eng\"\> EQUIPMENTS \</h1\>

\- 2 x Breadboard - 2 x ESP32-S3-DevKitC-1 (ESP32-S3 (1/2)) - 2 x 10K
Ohm Resistor - 1 x INMP441 - 1 x MH-FMD Passive Piezo Buzzer (Buzzer) -
1 x OLED Display IIC 0.96″ SSD1306 128x64 pixels (OLED) - 1 x 5 mm
Yellow LED (LED)

\-\--

\<h1 class=\"eng\"\>WORKING MECHANISM\</h1\>

For a simple explanation, we will divide this into 3 parts -- hardware,
software and firmware.

\<h2 class=\"eng\"\>\[ HARDWARE \]\</h2\>

There are 2 breadboards which one is used as an input board and another,
an output board.

\<h3\>First board: INPUT\</h3\>

\- \`ESP32-S3 (1)\` -- used for running the firmwares. - \`INMP441\` --
used for sound-waves input for \<span class=\"mode\"\>MODE 1\</span\>.

\<h3\>Second board: OUTPUT\</h3\>

\- \`ESP32-S3 (2)\` -- used for running the firmwares. - \`Buzzer\` --
used for any sound display to the user. - \`LED\` -- used for checking
whether the buzzer is working or not, however, it is not required. -
\`OLED\` -- used for various displays inside the modes to the screen.

\<h2 class=\"eng\"\>\[ SOFTWARE \]\</h2\>

For the software, we use the IoT system to communicate and receive or
publish data values which the protocol used is the Message Queuing
Telemetry Transport or MQTT by connecting the MQTT broker to
iot.cpe.ku.ac.th and adjust the data route in the Node-RED of the KU
server.

\<h3\> Node-RED \</h3\>

Node-RED has a major duty to control values received and published from
and to the MQTT broker. The user interface will be the Node-RED
Dashboard which the user can input values and view the outputs there.
Here is an example our flow and dashboard inside \<span
class=\"mode\"\>MODE 1\</span\>:

\<img src=\"https://i.postimg.cc/3R1gcnC0/IMG-1479.jpg\"
alt=\"GROUP17_Node-RED\" width=\"400\" display=\"inline-block\"\> \<img
src=\"https://i.postimg.cc/RFnVyFBr/IMG-1480.jpg\"
alt=\"GROUP17_Node-RED\" width=\"400\" display=\"inline-block\" \>

\<h3\> OVERALL \</h3\>

\<img src=\"https://i.postimg.cc/63q8rmNM/IMG-1484.jpg\" width=\"700\"
display=\"inline-block\"\>

\<h2 class=\"eng\"\>\[ FIRMWARE \]\</h2\>

For the firmware, we will describe the main functions of each files and
libraries, including the \<span class=\"file\"\>Arduino\</span\> in
\`ESP32-S3 (1)\` and \<span class=\"file\"\>Micropython\</span\> in
\`ESP32-S3 (2)\`.\<br\>

\<h3\>Arduino Files\</h3\>

\- \<span class=\"file\"\> FFT.ino \</span\> -- keep all the Arduino
libraries

\<h3\>Arduino Libraries\</h3\>

\- \<span class=\"file\"\> driver/i2s.h \</span\> -- communicate with
INMP441 - \<span class=\"file\"\> WiFi.h \</span\> -- Wifi connection -
\<span class=\"file\"\> PubSubClient.h \</span\> -- MQTT communication
\[\<a
href=\"https://github.com/knolleary/pubsubclient\"\>Source\</a\>\] -
\<span class=\"file\"\> arduinoFFT.h \</span\> -- perform FFT process
\[\<a href=\"https://github.com/kosme/arduinoFFT\"\>Source\</a\>\] -
\<span class=\"file\"\> config.h \</span\> -- Wifi, MQTT, Topics
configuration

\<h3\>Micropython Files\</h3\>

\- \<span class=\"file\"\> MAIN.py \</span\> -- running loop and
starting up the device. - \<span class=\"file\"\> MUSIC.py \</span\> --
keep all functions related to sound \<u\>e.g.\</u\> playmusic,
set_note. - \<span class=\"file\"\> OLED.py \</span\> -- keep all
functions related to OLED display. - \<span class=\"file\"\> CONNECT.py
\</span\> -- keep all functions related to connecting Wifi and MQTT. -
\<span class=\"file\"\> TOPIC.py \</span\> -- calling other functions,
receiving values and publish values to MQTT broker.

\<h3\>Micropython Libraries\</h3\> - \<span class=\"file\"\> time.pyi
\</span\> -- checking time used and time delay - \<span class=\"file\"\>
machine.pyi \</span\> -- setting Pins, PWM, etc. - \<span
class=\"file\"\> ssd1306.pyi \</span\> -- OLED configuration - \<span
class=\"file\"\> math.pyi \</span\> -- drawing on OLED calculation

\-\--

\<h1 class=\"eng\"\>FUNCTIONS\</h1\>

In this project, we have divided the system into 4 modes. Before
utilising each mode, please ensure that you have selected the mode from
the Node-RED Dashboard, otherwise, it will not work.

\<h2 class=\"eng\"\> MODE 1: Note Detector (Tuner) \</h2\>

This mode helps you to detect the input sound to the specified notes.
Each note will have their own standard frequency.

\- \<b\>Input :\</b\> Sound waveform directed to INMP441 - \<b\>Output
:\</b\> Detected note on Node-RED Dashboard and OLED. -
\<b\>Restrictions :\</b\> User might experience a high tolerance on
waveforms that are not sine wave and the sound waveform must not exceed
4,000 Hz.

\<h2 class=\"eng\"\> MODE 2: Note Display \</h2\> This mode simulates
the specific sound of the note from user's input.

\- \<b\>Input :\</b\> Note desired to be heard on Node-RED Dashboard. -
\<b\>Output :\</b\> Sound on buzzer and the input note on OLED.  -
\<b\>Restrictions :\</b\> The input note must be in the range of G2 to
B8.

\<h2 class=\"eng\"\> MODE 3: Metronome \</h2\> This mode displays the
BPM. The abbreviation "BPM" stands for "Beats per minute" which means
the amount of sound or beats you will hear in 1 minute. For example, 80
BPM means in 1 minute, you will hear 80 beats or you will hear a beat in
about 0.75 seconds.

\- \<b\>Input :\</b\> BPM desired on the Node-RED Dashboard. -
\<b\>Output :\</b\> Sound on buzzer and the input BPM on OLED.

\<h2 class=\"eng\"\> MODE 4: Sing a song \</h2\> In this mode, there
will be built-in songs that you can play on the buzzer.

\- \<b\>Input :\</b\> Select the desired song on the Node-RED
Dashboard. - \<b\>Output :\</b\> Song display on the buzzer.

\- - -

\<h1 class=\"eng\"\>MADE BY\</h1\>

\- 6610502102 -- Napatsanan Damaporn (Nan) - 6610505250 -- Kongphop
Tirattanaprakom (First) - 6610505314 -- Jurin Setsataworn (Korn) -
6610505438 -- Nakharet Mueangphakdee (Keng)

Department of Computer Engineering,\<br\> Faculty of Engineering,
Kasetsart University\<br\>

\-\--

\<sup\>This project is part of the course 01204114 Introduction to
Computer Hardware Development for the second semester of the academic
year 2023.\</sup\>
